{$N+}
{$E+}
program prog101;
uses Dos,Crt,Leader;
var M,R,R1,A,B,B1,C,C1,D,D1,E,E1,F,F1: real;
    ip: integer; {instruction pointer}
    p: array[1..128] of string;
    pp: string;
    i,nwiel: integer;
    nsz: integer;
    prog: text;
    q,titel: string;
    ok,trace,watchregs,klaar: boolean;
    cc: char;
    results: text;
    origmode: integer;
label 10,20;

procedure myhalt;
begin
   delay(1000);
   TextMode(origmode);
   halt
end;

procedure error(s: string);
begin
   writeln(s);
   writeln(results,s);
   close(results);
   myhalt
end;

procedure watch;
var x: char;
begin
   if watchregs then
      begin
         writeln(ip:3,': A,M,R:  ',A:8,M:8,R:8);
         writeln('     BCDEF:  ',B:8,C:8,D:8,E:8,F:8);
         writeln('     bcdef:  ',B1:8,C1:8,D1:8,E1:8,F1:8);
         repeat until keypressed; x:=readkey
      end
end;

procedure readvalue;
var q: string;
    code: integer;
begin
   repeat
   write(ip:3,'     >> '); readln(q);
   writeln(results,ip:3,'     >> ',q);
   klaar:=(q='q');
   val(q,M,code);
   until (code=0) or klaar;
   watch;
   ip:=ip+1;
end;

procedure roundoff(x: real; var y: real);
var s: string;
    code: integer;
begin
    Str(x:11:nwiel,s);
    Val(s,y,code);
    if code<>0 then Error('roundoff: invalid string representation')
end;

procedure printvalue;
var temp: real;
    reg: string;
begin
    reg:=p[ip][1]+p[ip][2];
    if reg = ' /' then
       begin
          writeln('-----------------------------');
          writeln(results,'-----------------------------');
       end
    else
       begin
          if reg = '  ' then temp:=M else
          if reg = 'R ' then temp:=R else
          if reg = 'A ' then temp:=A else
          if reg = 'B/' then temp:=B1 else
          if reg = 'B ' then temp:=B else
          if reg = 'C/' then temp:=C1 else
          if reg = 'C ' then temp:=C else
          if reg = 'D/' then temp:=D1 else
          if reg = 'D ' then temp:=D else
          if reg = 'E/' then temp:=E1 else
          if reg = 'E ' then temp:=E else
          if reg = 'F/' then temp:=F1 else
          if reg = 'F ' then temp:=F;
          writeln(ip:3,'     ',reg:2,' = ',temp:15:nwiel);
          writeln(results,ip:3,'     ',reg:2,' = ',temp:15:nwiel);
       end;
    watch;
    ip:=ip+1;
end;

procedure add;
var temp: real;
    reg: string;
begin
    if trace then writeln('add: ',ip:3);
    reg:=p[ip][1]+p[ip][2];
    if reg = '  ' then temp:=M else
    if reg = 'R ' then temp:=R else
    if reg = 'A ' then temp:=A else
    if reg = 'B/' then temp:=B1 else
    if reg = 'B ' then temp:=B else
    if reg = 'C/' then temp:=C1 else
    if reg = 'C ' then temp:=C else
    if reg = 'D/' then temp:=D1 else
    if reg = 'D ' then temp:=D else
    if reg = 'E/' then temp:=E1 else
    if reg = 'E ' then temp:=E else
    if reg = 'F/' then temp:=F1 else
    if reg = 'F ' then temp:=F else
    error('add: register unrecognized');
    M:=temp;
    R:=A+M;
    roundoff(R,A);
    watch;
    ip:=ip+1;
end;

procedure subtr;
var temp: real;
    reg: string;
begin
    if trace then writeln('subtr: ',ip:3);
    reg:=p[ip][1]+p[ip][2];
    if reg =  '  ' then temp:=M else
    if reg =  'M ' then temp:=M else    {NB ook in andere functies doen!?}
    if reg =  'R ' then temp:=R else
    if reg =  'A ' then temp:=A else
    if reg =  'B/' then temp:=B1 else
    if reg =  'B ' then temp:=B else
    if reg =  'C/' then temp:=C1 else
    if reg =  'C ' then temp:=C else
    if reg =  'D/' then temp:=D1 else
    if reg =  'D ' then temp:=D else
    if reg =  'E/' then temp:=E1 else
    if reg =  'E ' then temp:=E else
    if reg =  'F/' then temp:=F1 else
    if reg =  'F ' then temp:=F else
    error('subtr: register unrecognized');
    M:=temp;
    R:=A-M;
    roundoff(R,A);
    watch;
    ip:=ip+1;
end;

procedure mult;
var temp: real;
    reg: string;
begin
    if trace then writeln('mult: ',ip:3);
    reg:=p[ip][1]+p[ip][2];
    if reg =  '  ' then temp:=M else
    if reg =  'R ' then temp:=R else
    if reg =  'A ' then temp:=A else
    if reg =  'B/' then temp:=B1 else
    if reg =  'B ' then temp:=B else
    if reg =  'C/' then temp:=C1 else
    if reg =  'C ' then temp:=C else
    if reg =  'D/' then temp:=D1 else
    if reg =  'D ' then temp:=D else
    if reg =  'E/' then temp:=E1 else
    if reg =  'E ' then temp:=E else
    if reg =  'F/' then temp:=F1 else
    if reg =  'F ' then temp:=F else
    error('mult: register unrecognized');
    M:=temp;
    R:=A*M;
    roundoff(R,A);
    watch;
    ip:=ip+1;
end;

procedure root;
var temp: real;
    reg: string;
begin
    if trace then writeln('root: ',ip:3);
    reg:=p[ip][1]+p[ip][2];
    if reg =  '  ' then temp:=M else
    if reg =  'R ' then temp:=R else
    if reg =  'A ' then temp:=A else
    if reg =  'B/' then temp:=B1 else
    if reg =  'B ' then temp:=B else
    if reg =  'C/' then temp:=C1 else
    if reg =  'C ' then temp:=C else
    if reg =  'D/' then temp:=D1 else
    if reg =  'D ' then temp:=D else
    if reg =  'E/' then temp:=E1 else
    if reg =  'E ' then temp:=E else
    if reg =  'F/' then temp:=F1 else
    if reg =  'F ' then temp:=F else
    error('root: register unrecognized');
    roundoff(sqrt(abs(temp)),A);
    M:=2*A;
    watch;
    ip:=ip+1
end;

procedure divid;
var temp: real;
    reg: string;
begin
    if trace then writeln('divid: ',ip:3);
    reg:=p[ip][1]+p[ip][2];
    if reg =  '  ' then temp:=M else
    if reg =  'R ' then temp:=R else
    if reg =  'A ' then temp:=A else
    if reg =  'B/' then temp:=B1 else
    if reg =  'B ' then temp:=B else
    if reg =  'C/' then temp:=C1 else
    if reg =  'C ' then temp:=C else
    if reg =  'D/' then temp:=D1 else
    if reg =  'D ' then temp:=D else
    if reg =  'E/' then temp:=E1 else
    if reg =  'E ' then temp:=E else
    if reg =  'F/' then temp:=F1 else
    if reg =  'F ' then temp:=F else
    error('divide: register unrecognized');
    M:=temp;
    temp:=A/M;   {werkelijk quotient}
    roundoff(temp,A);  {A bevat afgerond quotient}
    R:=M*(temp-A); {rest}
    watch;
    ip:=ip+1
end;

procedure sto;
var reg: string;
begin
    if trace then writeln('sto: ',ip:3);
    reg:=p[ip][1]+p[ip][2];
    if reg =  'B/' then B1:=M else
    if reg =  'B ' then B:=M else
    if reg =  'C/' then C1:=M else
    if reg =  'C ' then C:=M else
    if reg =  'D/' then D1:=M else
    if reg =  'D ' then D:=M else
    if reg =  'E/' then E1:=M else
    if reg =  'E ' then E:=M else
    if reg =  'F/' then F1:=M else
    if reg =  'F ' then F:=M else
    error('store: register unrecognized');
    watch;
    ip:=ip+1
end;

procedure get;
var reg: string;
begin
    if trace then writeln('get: ',ip:3);
    reg:=p[ip][1]+p[ip][2];
    if reg =  '  ' then A:=M else
    if reg =  'R ' then A:=R else
    if reg =  'B/' then A:=B1 else
    if reg =  'B ' then A:=B else
    if reg =  'C/' then A:=C1 else
    if reg =  'C ' then A:=C else
    if reg =  'D/' then A:=D1 else
    if reg =  'D ' then A:=D else
    if reg =  'E/' then A:=E1 else
    if reg =  'E ' then A:=E else
    if reg =  'F/' then A:=F1 else
    if reg =  'F ' then A:=F else
    error('get: register unrecognized');
    watch;
    ip:=ip+1
end;

procedure swap;
var temp: real;
    reg: string;
begin
    if trace then writeln('swap: ',ip:3);
    reg:=p[ip][1]+p[ip][2];
    if reg =  'A ' then A:=abs(A) else
    if reg =  ' /' then M:=frac(A) else
    if reg =  '  ' then begin temp:=M;  M:=A;  A:=temp end else
    if reg =  'R ' then begin temp:=R;  R:=A;  A:=temp end else
    if reg =  'B/' then begin temp:=B1; B1:=A; A:=temp end else
    if reg =  'B ' then begin temp:=B;  B:=A;  A:=temp end else
    if reg =  'C/' then begin temp:=C1; C1:=A; A:=temp end else
    if reg =  'C ' then begin temp:=C;  C:=A;  A:=temp end else
    if reg =  'D/' then begin temp:=D1; D1:=A; A:=temp end else
    if reg =  'D ' then begin temp:=D;  D:=A;  A:=temp end else
    if reg =  'E/' then begin temp:=E1; E1:=A; A:=temp end else
    if reg =  'E ' then begin temp:=E;  E:=A;  A:=temp end else
    if reg =  'F/' then begin temp:=F1; F1:=A; A:=temp end else
    if reg =  'F ' then begin temp:=F;  F:=A;  A:=temp end else
    error('swap: register unrecognized');
    watch;
    ip:=ip+1;
end;

procedure swapRS;
var temp: real;
begin
    if trace then writeln('swapRS: ',ip:3);
    temp:=D;   D:=R;    R:=temp;
    temp:=D1;  D1:=R1;  R1:=temp; {enige plaats waar ik R1 gebruik}
    watch;
    ip:=ip+1;
end;

procedure clear;
var reg: string;
begin
    if trace then writeln('clear: ',ip:3);
    reg:=p[ip][1]+p[ip][2];
    if reg =  'A ' then A:=0.0 else
    if reg =  'R ' then R:=0.0 else
    if reg =  'B/' then B1:=0.0 else
    if reg =  'B ' then B:=0.0 else
    if reg =  'C/' then C1:=0.0 else
    if reg =  'C ' then C:=0.0 else
    if reg =  'D/' then D1:=0.0 else
    if reg =  'D ' then D:=0.0 else
    if reg =  'E/' then E1:=0.0 else
    if reg =  'E ' then E:=0.0 else
    if reg =  'F/' then F1:=0.0 else
    if reg =  'F ' then F:=0.0 else
    error('clear: register unrecognized');
    watch;
    ip:=ip+1
end;

function getip(adres: string): integer;
var i: integer;
begin
     i:=1;
     repeat
     if p[i]=adres then begin getip:=i; exit end;
     i:=i+1;
     until (i>nsz);
     if i>nsz then error('getip: address '+adres+' not found')
end;

procedure branch; {unconditional jump}
var op: string;
begin
    op:=p[ip];
    if trace then writeln('branch (uc): ',ip:3);
    if op =  '  V' then ip:=getip('A V') else
    if op =  '  W' then ip:=getip('A W') else
    if op =  '  Y' then ip:=getip('A Y') else
    if op =  '  Z' then ip:=getip('A Z') else
    if op =  'C V' then ip:=getip('B V') else
    if op =  'C W' then ip:=getip('B W') else
    if op =  'C Y' then ip:=getip('B Y') else
    if op =  'C Z' then ip:=getip('B Z') else
    if op =  'D V' then ip:=getip('E V') else
    if op =  'D W' then ip:=getip('E W') else
    if op =  'D Y' then ip:=getip('E Y') else
    if op =  'D Z' then ip:=getip('E Z') else
    if op =  'R V' then ip:=getip('F V') else
    if op =  'R W' then ip:=getip('F W') else
    if op =  'R Y' then ip:=getip('F Y') else
    if op =  'R Z' then ip:=getip('F Z') else
    error('branch: operator unrecognized');
end;

procedure jump; {conditional jump}
var temp: real;
    op: string;
begin
    op:=p[ip];
    if trace then writeln('jump (c): ',ip:3);
    if A<=0 then  begin ip:=ip+1; exit end;
    if op =  ' /V' then ip:=getip('A/V') else
    if op =  ' /W' then ip:=getip('A/W') else
    if op =  ' /Y' then ip:=getip('A/Y') else
    if op =  ' /Z' then ip:=getip('A/Z') else
    if op =  'C/V' then ip:=getip('B/V') else
    if op =  'C/W' then ip:=getip('B/W') else
    if op =  'C/Y' then ip:=getip('B/Y') else
    if op =  'C/Z' then ip:=getip('B/Z') else
    if op =  'D/V' then ip:=getip('E/V') else
    if op =  'D/W' then ip:=getip('E/W') else
    if op =  'D/Y' then ip:=getip('E/Y') else
    if op =  'D/Z' then ip:=getip('E/Z') else
    if op =  'R/V' then ip:=getip('F/V') else
    if op =  'R/W' then ip:=getip('F/W') else
    if op =  'R/Y' then ip:=getip('F/Y') else
    if op =  'R/Z' then ip:=getip('F/Z') else
    error('jump: operator unrecognized');
end;

procedure loadconst;
var key1,key2,key3: char;
    i,len,code,save_ip: integer;
    min,plus,links: boolean;
    digit: array[1..11] of char;
    komma: array[1..11] of boolean;
    num: string;
    x: real;
begin
   i:=0;
   save_ip:=ip;
   repeat
       ip:=ip+1;
       key1:= p[ip][1];
       key2:= p[ip][2];
       key3:= p[ip][3];
       i:=i+1;
       if key3 = 'S' then digit[i]:='0' else
       if key3 = '$' then digit[i]:='1' else
       if key3 = '^' then digit[i]:='2' else
       if key3 = '&' then digit[i]:='3' else
       if key3 = '+' then digit[i]:='4' else
       if key3 = '-' then digit[i]:='5' else
       if key3 = '*' then digit[i]:='6' else
       if key3 = ':' then digit[i]:='7' else
       if key3 = '%' then digit[i]:='8' else
       if key3 = '!' then digit[i]:='9';
       plus := (key1='D') or (key1='R');
       min   :=(key1='E') or (key1='F');
       komma[i] := (key2='/');
       links :=(key1='D') or (key1='E');
   until links;
   if plus and min then error('loadconst: indeterminate sign');
   len:=i;
   num:='';
   for i:=len downto 1 do
     begin
        num:=num+digit[i];
        if komma[i] then num:=num+'.';
     end;
   val(num,x,code);
   if plus then M:=x else if min then M:=-x
                     else error('loadconst: sign undefined');
   ip:=ip+1;
   if trace then writeln('constant at ',save_ip:3,' = ' ,M);
   if code<>0 then error('loadconst: not able to retrieve number')
end;

procedure execute;
var key1,key2,key3: char;
begin
    klaar:=false;
    REPEAT
(*  write('exec: ip = ',ip:3,'   ');   *)
    key1:=p[ip][1];
    key2:=p[ip][2];
    key3:=p[ip][3];
(*  writeln(key1:3,key2:3,key3:3);  *)

    if p[ip]='A/^' then loadconst  else
    if p[ip]='R S' then swapRS  else
    if key3 =  '+' then add     else
    if key3 =  '-' then subtr   else
    if key3 =  '*' then mult    else
    if key3 =  ':' then divid   else
    if key3 =  '#' then root    else
    if key3 =  '^' then sto     else
    if key3 =  '$' then get     else
    if key3 =  '&' then swap    else
    if key3 =  '!' then clear   else
    if key3 =  'S' then readvalue   else
    if key3 =  '%' then printvalue  else
    {is op a jump or branch point?}
    if key3 in ['V','W','Y','Z'] then        {both starts and destinations}
       begin
          if (key1 in [' ','C','D','R']) then
              begin
                if (key2='/') then jump else branch
              end
          else ip:=ip+1   {op must be an address specificator}
       end
    else error('exec: non executable code!');
    UNTIL klaar
end;

{$I-}
procedure init_regs;
var reg: string;
    x: real;
    s: string;
    q: char;
begin
    M:=0; A:=0; R:=0;
    B:=0; C:=0; D:=0; E:=0; F:=0;
    B1:=0; C1:=0; D1:=0; E1:=0; F1:=0;
    writeln('=== card constants ===');
    repeat
       write('enter register BCDEF[/] or c(ontinue) > '); readln(reg);
       if reg<>'c' then
         begin
            write('enter value > ');  readln(x);
            if IOResult<>0 then error('invalid input');
            if reg = 'B' then B:=x  else
            if reg = 'B/' then B1:=x else
            if reg = 'C' then C:=x  else
            if reg = 'C/' then C1:=x else
            if reg = 'D' then D:=x  else
            if reg = 'D/' then D1:=x else
            if reg = 'E' then E:=x  else
            if reg = 'E/' then E1:=x else
            if reg = 'F' then F:=x  else
            if reg = 'F/' then F1:=x else
            error('init_regs: non-existent register');
         end;
    until reg='c';
    writeln('=== program initialization ===');
    repeat
       write('enter register MBCDEF[/] or c(ontinue) > '); readln(reg);
       if reg<>'c' then
         begin
            write('enter value > ');  readln(M);
            if IOResult<>0 then error('invalid input');
            if reg = 'M' then else
            if reg = 'B' then B:=M  else
            if reg = 'B/' then B1:=M else
            if reg = 'C' then C:=M  else
            if reg = 'C/' then C1:=M else
            if reg = 'D' then D:=M  else
            if reg = 'D/' then D1:=M else
            if reg = 'E' then E:=M  else
            if reg = 'E/' then E1:=M else
            if reg = 'F' then F:=M  else
            if reg = 'F/' then F1:=M else
            error('init_regs: non-existent register');
         end;
    until reg='c';
    watch;
end;
{$I+}

function start(key: char): boolean; {go to start address}
var temp: real;
    ok: boolean;
begin
    ok:=true;
    if key = 'V' then ip:=getip('A V') else
    if key=  'W' then ip:=getip('A W') else
    if key=  'Y' then ip:=getip('A Y') else
    if key=  'Z' then ip:=getip('A Z') else
    ok:=false;
    if ok then writeln('==================================');
    if ok then writeln(results,'==================================');
    if ok then writeln(results,'program starts at instr ',ip:4);
    start:=ok;
end;

begin {main}
    origmode:=LastMode;
    hello('Olivetti Programma 101 Electronic Desk-top Calculator (1968)',
    'program card processing emulator', 'version 0.1, August, 1996');
    SetCBreak(true);
    TextBackground(blue);
    TextColor(lightgray);
    trace:=false;
    watchregs:=false;
    assign(results,'results');
    rewrite(results);
    ClrScr;
    {$I-}
    write('enter program filename > '); readln(q);
    writeln(results,'program ',q);
    assign(prog,q);
    reset(prog);
    if IOResult<>0 then error('nonexistent program file');
    i:=0;
    while not eof(prog) do
      begin
        readln(prog,pp);
        if pp[1]='#' then
            begin
              TextColor(green);
              writeln(pp);
              TextColor(lightgray);
              writeln(results,pp)
            end
        else
           begin
              i:=i+1;
              if not (pp[2] in [' ','/'])
                            then error('main: error in prog data');
              p[i]:=pp
           end
      end;
    nsz:=i;
    writeln('number of instructions = ',nsz:4);
    write('enter decimal wheel position > '); readln(nwiel);
    if (IOResult<>0) or (not (nwiel in [0..15])) then error('invalid number');
    ip:=0;
    init_regs;
10: repeat
       write('enter start address VWYZ or q(uit) PROG101 > '); readln(cc);
       if cc='q' then goto 20 else ok:=start(cc)
    until ok;  {sets instruction pointer}
    execute;
    goto 10;
20: close(results);
    myhalt
end.
{$I+}

