program seq2con;   {om quasi-instructiecode naar getal te vertalen}
uses Dos,Crt,Leader;
var q,numstring: string;
    x: real;
    i,nn,n: integer;
    comma,signflag,leftmost,positive,negative: boolean;
    s,number: array[1..20] of string;
    c: char;
label 1,2;

procedure error(s: string);
begin
   writeln(s);
   halt
end;

function sym2num(q: char): char;
var s: char;
begin
    case q of
      'S': s:='0';
      '$': s:='1';
      '^': s:='2';
      '&': s:='3';
      '+': s:='4';
      '-': s:='5';
      '*': s:='6';
      ':': s:='7';
      '%': s:='8';
      '!': s:='9'
    end;
    sym2num:=s
end;

begin
   hello('Olivetti Programma 101 Electronic Desk-top Calculator (1968)',
   'quasi-instructions to constant translator', 'version 0.1, August, 1996');
   REPEAT
   ClrScr;
1: writeln('enter quasi-instruction sequence, terminated by 000: ');
   n:=1;
   repeat
      readln(q);
      s[n]:=q;
      n:=n+1
   until q='000';
   n:=n-2;
   if not (s[1]='A/^') then error('first triple must be A/^');
   nn:=0;
   for i:=2 to n do
     begin
        q:=s[i];
        leftmost:=(q[1] in ['D','E']);
        positive:=(q[1] in ['D','R']);
        negative:=(q[1] in ['E','F']);
        comma:=(q[2]='/');
        number[i]:=sym2num(q[3]);
        if comma then number[i]:=number[i]+'.';
        if i=2 then signflag:=positive;
        if signflag and negative then error('sign inconsistency');
        if (not signflag) and positive then error('sign inconsistency');
        if leftmost then begin nn:=i; goto 2 end
     end;
2: if nn<n then error('sequence length less than specified');
   if nn=0 then error('sequence not properly terminated');
   numstring:='';
   for i:=nn downto 2 do numstring:=numstring+number[i];
   if not signflag then insert('-',numstring,1);
   writeln('encoded constant is ',numstring);
   writeln;
   writeln('type <esc> for leaving this program');
   c:=readkey;
   UNTIL c=chr(27);
end.

